Subject: bug#48166: Dont stop the upgrade process - Better guix handling when Package failed to build

From: Julien Lepiller <[email-masked]>
Date: Sun, 02 May 2021 21:50:39 -0400

I don't think --keep-going works as you expect it to. When you do guix upgrade, guix creates a derivation for your new profile and proceeds to build it. If it has dependents that need to be built (packages that were updated), it builds them as they are needed to build the new profile.

If one of them fails, guix fails early by default. --keep-going will, well, keep going and guix will build the rest of the dependents that are independent from that failure.

However, it will eventually fail (late) when it tries to finally build the derivation for the new derivation: itqdepends on other derivations that already failed. Not sure how it reports the failures, but it might be easier to list all the failures in one try, and apply your workaround.

To do what you want (create a new generations ignoring failures) is not easy to implement. We would have to "change our mind" and build a different derivation for that new profile.

Le 2 mai 2021 21:00:02 GMT-04:00, bo0od <[email-masked]> a écrit :
> > I think you can use `guix package --upgrade . --keep-going`:
>
>Thank you for the hint, sorry i didnt know this command exist.
>
>Currently i cant test this because i dont have a package which has an 
>error in the building (previous icedove bug should be fixed) to see how
>
>this is going to go.
>
>- First question:
>
>Why this is not default? and what not default should be:
>
>--stop-at-error or --dont-proceed-error ..(or whatever)
>
>- Second question:
>
>Does it show the error at the end or during the upgrade or both (same
>as 
>my example before)? So user is aware that one or more of his packages 
>didnt upgraded.
>
>- If second question is yes then that command can replace 
>--do-not-upgrade in my previous workaround faster implementation but
>not 
>ultimate.
>
>
>
>
>Leo Famulari:
>> On Sun, May 02, 2021 at 08:29:31PM +0000, bo0od wrote:
>>> Current (manual) solution is:
>>>
>>> guix package --upgrade . --do-not-upgrade x
>> 
>> I think you can use `guix package --upgrade . --keep-going`:
>> 
>>
>https://guix.gnu.org/manual/devel/en/html_node/Common-Build-Options.html
>> 
>> --keep-going
>> -k
>> 
>>      Keep going when some of the derivations fail to build; return
>only once all the builds have either completed or failed.
>> 
>>      The default behavior is to stop as soon as one of the specified
>derivations has failed.
>>